#include <Arduino.h>

//https://ardwinner.jimdofree.com/arduino/iv-les-moteurs-continus/3-faire-tourner-un-moteur-dc-bidirectionnel-avec-un-module-l298n/
//https://arduino.blaisepascal.fr/pont-en-h-l298n/
//https://www.mataucarre.fr/index.php/2019/03/09/utiliser-un-potentiometre-avec-un-arduino/

//declaration des variables et des constantes
int enA = 9; //les pins avec des tilds
int in1 = 10;
int in2 = 11;
int pot; //valeur du potentiometre

int speedmotor = 0; //vitesse du moteur

void setup() {
  // put your setup code here, to run once:
  pinMode(enA, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  Serial.begin(9600); //la valeur de communication
}

void move(int speed, bool testforward) {// speed between 0 and 255 analog write, test d'un booléen pour aller dans un sens ou dans un autre
  if (testforward){
    digitalWrite(in1, HIGH); //envoie du courant dans un sens (set to +)
    digitalWrite(in2, LOW); //en envoie pas, le récupère (set to -)
  }
  else{
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
  }
  analogWrite(enA, speed);
}

void loop() {
  // put your main code here, to run repeatedly:
  if(Serial.available() > 0){ //si la board arduino est branchée
    speedmotor = Serial.parseInt(); // speedmotor recupere la valeur inscrite dans le serial
    Serial.println(speedmotor);
    if (speedmotor == 0){
      return;
    }
    if(speedmotor > 0){ //si speedmoto a une valeur, plus grande que 0
      if (speedmotor > 255){
        speedmotor = 255; //speedmotor est forcé à 255 maxi
      }
      move(speedmotor, true); //alors marche avant
    }
    else if(speedmotor < -1){
      speedmotor = -1*speedmotor; //pour que la vitesse ait une valeur de vitesse mais en marche arrière
      if (speedmotor > 255){ //recopiage du test parce que speedmotor est de nouveau positif
        speedmotor = 255; //speedmotor est forcé à 255 maxi
      }
      move(speedmotor,false); //marche arriere
    }
    else if(speedmotor == -1){ //c'est zero donc tout s'arrete
      digitalWrite(in1, LOW);
      digitalWrite(in2, LOW);
    }    
  } 
}


